/* This software is covered by the GNU GENERAL PUBLIC LICENSE (GPL). */
/* $Revision: 1 $ */
/* $Date: 2/22/06 10:06a $ */
/*
*	HPDI32-DIPHASE2
*/
/* $Log: /NEW SOURCESAFE DATABASE/DIGITAL/Drivers/LINUX/HPDI32_Linux/HPDI32_Linux_Ver.1.13.0-GSC-DN/diphase2/lib/hpdi32_diphase2.h $
 *
 * 1     2/22/06 10:06a Dnewbold
*/

#if !defined(__HPDI32_DIPHASE2_H__) && !defined(__HPDI32_H__)
#define __HPDI32_DIPHASE2_H__

#define HPDI32_GSC_REGS_EXCLUDE
#include "hpdi32.h"



/* #defines	**************************************************************/

#define	HPDI32_DP2__RX_ENABLE(fd)	hpdi32_dp2_rx_config_set(fd,1,-1,-1,-1)
#define	HPDI32_DP2__RX_DISABLE(fd)	hpdi32_dp2_rx_config_set(fd,0,-1,-1,-1)

#define	HPDI32_DP2__TX_ENABLE(fd)	hpdi32_dp2_tx_config_set(fd,1,-1,-1,-1,-1)
#define	HPDI32_DP2__TX_DISABLE(fd)	hpdi32_dp2_tx_config_set(fd,0,-1,-1,-1,-1)

#define	HPDI32_DP2__TX_START(fd)	hpdi32_dp2_tx_config_set(fd,-1,1,-1,-1,-1)
#define	HPDI32_DP2__TX_STOP(fd)		hpdi32_dp2_tx_config_set(fd,-1,0,-1,-1,-1)

#define	HPDI32_GSC_FRR		HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x00)
#define	HPDI32_GSC_BCR		HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x04)
#define	HPDI32_GSC_BSR		HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x08)
#define	HPDI32_GSC_TAR		HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x0C)
#define	HPDI32_GSC_RAR		HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x10)
#define	HPDI32_GSC_TXODPR	HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x14)
#define	HPDI32_GSC_FDR		HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x18)
#define	HPDI32_GSC_TXMLSR	HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x1C)
#define	HPDI32_GSC_TXMLCR	HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x20)
#define	HPDI32_GSC_TXPDLR	HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x24)
#define	HPDI32_GSC_RXIDPR	HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x28)
#define	HPDI32_GSC_RXMLSR	HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x2C)
#define	HPDI32_GSC_ICR		HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x30)
#define	HPDI32_GSC_ISR		HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x34)
#define	HPDI32_GSC_IELR		HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x50)
#define	HPDI32_GSC_IHLR		HPDI32_REG_ENCODE(HPDI32_GSC_REGISTER, 4, 0x54)

// Board Control Register macros
#define	HPDI32_GSC_BCR_BOARD_RESET		0x00000001
#define	HPDI32_GSC_BCR_TX_FIFO_RESET	0x00000002
#define	HPDI32_GSC_BCR_RX_FIFO_RESET	0x00000004
#define	HPDI32_GSC_BCR_TX_ENABLE		0x00000010
#define	HPDI32_GSC_BCR_RX_ENABLE		0x00000020
#define	HPDI32_GSC_BCR_CC_D5_D6_DISABLE	0x00000040
#define	HPDI32_GSC_BCR_LOOP_BACK		0x00000080
#define	HPDI32_GSC_BCR_TX_START			0x00000100
#define	HPDI32_GSC_BCR_PO_07_00_ENABLE	0x00001000
#define	HPDI32_GSC_BCR_PO_15_08_ENABLE	0x00002000
#define	HPDI32_GSC_BCR_PO_23_16_ENABLE	0x00004000
#define	HPDI32_GSC_BCR_PO_31_24_ENABLE	0x00008000
#define	HPDI32_GSC_BCR_TX_BIG_ENDIAN	0x00010000
#define	HPDI32_GSC_BCR_TX_RAW_OUTPUT	0x00020000
#define	HPDI32_GSC_BCR_TX_PD_LEVEL		0x00040000
#define	HPDI32_GSC_BCR_TX_PD_ENABLE		0x00080000
#define	HPDI32_GSC_BCR_RX_BIG_ENDIAN	0x01000000
#define	HPDI32_GSC_BCR_RX_HDR_SIZE_14	0x02000000
#define	HPDI32_GSC_BCR_RX_ALL_DATA		0x04000000

// Board Status Register macros
#define	HPDI32_GSC_BSR_D_MASK			0x0000007F
#define	HPDI32_GSC_BSR_D0				0x00000001
#define	HPDI32_GSC_BSR_D1				0x00000002
#define	HPDI32_GSC_BSR_D2				0x00000004
#define	HPDI32_GSC_BSR_D3				0x00000008
#define	HPDI32_GSC_BSR_D4				0x00000010
#define	HPDI32_GSC_BSR_D5				0x00000020
#define	HPDI32_GSC_BSR_D6				0x00000040
#define	HPDI32_GSC_BSR_TX_DONE			0x00000080
#define	HPDI32_GSC_BSR_TX_MASK			0x00000F00
#define	HPDI32_GSC_BSR_TX_NOT_EMPTY		0x00000100
#define	HPDI32_GSC_BSR_TX_NOT_AE		0x00000200
#define	HPDI32_GSC_BSR_TX_NOT_AF		0x00000400
#define	HPDI32_GSC_BSR_TX_NOT_FULL		0x00000800
#define	HPDI32_GSC_BSR_RX_MASK			0x0000F000
#define	HPDI32_GSC_BSR_RX_NOT_EMPTY		0x00001000
#define	HPDI32_GSC_BSR_RX_NOT_AE		0x00002000
#define	HPDI32_GSC_BSR_RX_NOT_AF		0x00004000
#define	HPDI32_GSC_BSR_RX_NOT_FULL		0x00008000
#define	HPDI32_GSC_BSR_BJ0				0x00010000
#define	HPDI32_GSC_BSR_BJ1				0x00020000
#define	HPDI32_GSC_BSR_RX_UNDERRUN		0x00080000
#define	HPDI32_GSC_BSR_RX_OVERRUN		0x00100000
#define	HPDI32_GSC_BSR_TX_OVERRUN		0x00200000
#define	HPDI32_GSC_BSR_RX_DONE			0x00400000
#define	HPDI32_GSC_BSR_RX_BUSY			0x00800000
#define	HPDI32_GSC_BSR_RX_RUNNING		0x01000000
#define	HPDI32_GSC_BSR_TX_BUSY			0x02000000
#define	HPDI32_GSC_BSR_TX_CABLE			0x04000000

// Tx Almost Register macros
#define	HPDI32_GSC_TAR_ENCODE(f,e)		(HPDI32_ENCODE(f,31,16) | \
										 HPDI32_ENCODE(e,15, 0))
#define	HPDI32_GSC_TAR_DECODE_EMPTY(r)	HPDI32_DECODE( r,15, 0)
#define	HPDI32_GSC_TAR_DECODE_FULL(r)	HPDI32_DECODE( r,31,16)

// Rx Almost Register macros
#define	HPDI32_GSC_RAR_ENCODE(f,e)		(HPDI32_ENCODE(f,31,16) | \
										 HPDI32_ENCODE(e,15, 0))
#define	HPDI32_GSC_RAR_DECODE_EMPTY(r)	HPDI32_DECODE( r,15, 0)
#define	HPDI32_GSC_RAR_DECODE_FULL(r)	HPDI32_DECODE( r,31,16)

// Interrupt register bits (ICR, ISR, IELR, IHLR)
#define	HPDI32_INT_GSC_TX_DATA_RISE		0x00000001
#define	HPDI32_INT_GSC_TX_DATA_FALL		0x00000002
#define	HPDI32_INT_GSC_TX_DATA_1		0x00000004
#define	HPDI32_INT_GSC_CC2_1			0x00000008
#define	HPDI32_INT_GSC_CC4_1			0x00000010
#define	HPDI32_INT_GSC_CC5_1			0x00000020
#define	HPDI32_INT_GSC_CC6_1			0x00000040
#define	HPDI32_INT_GSC_TX_DONE			0x00000080
#define	HPDI32_INT_GSC_TX_FIFO_EMPTY	0x00000100
#define	HPDI32_INT_GSC_TX_FIFO_AE		0x00000200
#define	HPDI32_INT_GSC_TX_FIFO_AF		0x00000400
#define	HPDI32_INT_GSC_TX_FIFO_FULL		0x00000800
#define	HPDI32_INT_GSC_RX_FIFO_EMPTY	0x00001000
#define	HPDI32_INT_GSC_RX_FIFO_AE		0x00002000
#define	HPDI32_INT_GSC_RX_FIFO_AF		0x00004000
#define	HPDI32_INT_GSC_RX_FIFO_FULL		0x00008000
#define	HPDI32_INT_GSC_RX_FIFO_UNDER	0x00010000
#define	HPDI32_INT_GSC_RX_FIFO_OVER		0x00020000
#define	HPDI32_INT_GSC_TX_FIFO_OVER		0x00040000
#define	HPDI32_INT_GSC_RX_DONE			0x00080000
#define	HPDI32_INT_GSC_RX_BUSY			0x00100000
#define	HPDI32_INT_GSC_RX_RUNNING		0x00200000
#define	HPDI32_INT_GSC_TX_BUSY			0x00400000
#define	HPDI32_INT_GSC_TX_DRIVE			0x00800000



/* prototypes	**************************************************************/

int	hpdi32_dp2_board_loop_back_get(int fd, int* enable);
int	hpdi32_dp2_board_loop_back_set(int fd, int enable);
int	hpdi32_dp2_board_reset(int fd);
int	hpdi32_dp2_gpio_mod(int fd, __u32 value, __u32 mask);
int	hpdi32_dp2_gpio_read(int fd, __u32* value);
int	hpdi32_dp2_gpio_write(int fd, __u32 value);
int	hpdi32_dp2_predrive_get(int fd, int* enable, int* high, int* count);
int	hpdi32_dp2_predrive_set(int fd, int enable, int high, int count);
int	hpdi32_dp2_reg_mod(int fd, __u32 reg, __u32 value, __u32 mask);
int	hpdi32_dp2_reg_read(int fd, __u32 reg, __u32* value);
int	hpdi32_dp2_reg_write(int fd, __u32 reg, __u32 value);
int	hpdi32_dp2_rx_accum_msg_size(int fd, __u32* size);
int	hpdi32_dp2_rx_fifo_almost_get(int fd, int* af, int* ae);
int	hpdi32_dp2_rx_fifo_almost_set(int fd, int af, int ae);
int	hpdi32_dp2_rx_fifo_reset(int fd);
int	hpdi32_dp2_tx_fifo_almost_get(int fd, int* af, int* ae);
int	hpdi32_dp2_tx_fifo_almost_set(int fd, int af, int ae);
int	hpdi32_dp2_tx_fifo_reset(int fd);
int	hpdi32_dp2_tx_last_msg_size(int fd, __u32* size);

int		hpdi32_dp2_gpio_dir_get(	int		fd,
									int*	out_hwhb,
									int*	out_hwlb,
									int*	out_lwhb,
									int*	out_lwlb);

int		hpdi32_dp2_gpio_dir_set(	int		fd,
									int		out_hwhb,
									int		out_hwlb,
									int		out_lwhb,
									int		out_lwlb);

int		hpdi32_dp2_rx_config_get(	int		fd,
									int*	enable,
									int*	big_e,
									int*	hdr_size,
									int*	all_data);

int		hpdi32_dp2_rx_config_set(	int		fd,
									int		enable,
									int		big_e,
									int		hdr_size,
									int		all_data);

int		hpdi32_dp2_tx_config_get(	int		fd,
									int*	enable,
									int*	start,
									int*	big_e,
									int*	raw,
									__u32*	length);

int		hpdi32_dp2_tx_config_set(	int		fd,
									int		enable,
									int		start,
									int		big_e,
									int		raw,
									__s32	length);

void	hpdi32_dp2_lib_version_get(	char*	version,
									size_t	vsize,
									char*	built,
									size_t	bsize);



#endif
