/* This software is covered by the GNU GENERAL PUBLIC LICENSE (GPL). */
#include <stdio.h>
#include <string.h>

#include "hpdi32_diphase2.h"



/* #defines	******************************************************************/

#define	VERSION	"1.00"
// 1.00	Initial release.



/******************************************************************************
*
*	Function:	hpdi32_dp2_lib_version_get
*
*	Purpose:
*
*		Give the caller the library version number.
*
*	Arguments:
*
*		version	The version number is recorded here. This should be
*				at least five bytes long.
*
*		vsize	This is the size of the above buffer.
*
*		built	The date and time the library was built. This is a string
*				if the format printf("%s, %s", __DATE__, __TIME__);.
*
*		bsize	This is the size of the above buffer.
*
*	Returned:
*
*		None.
*
******************************************************************************/

void hpdi32_dp2_lib_version_get(
	char*	version,
	size_t	vsize,
	char*	built,
	size_t	bsize)
{
	char	buf[64];

	if ((version) && (vsize))
	{
		strncpy(version, VERSION, vsize);
		version[bsize - 1]	= 0;
	}

	if ((built) && (bsize))
	{
		sprintf(buf, "%s, %s", __DATE__, __TIME__);
		strncpy(built, buf, bsize);
		built[bsize - 1]	= 0;
	}
}



